﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=9.85
@EndOfDesignText@
#Region Shared Files
#CustomBuildAction: folders ready, %WINDIR%\System32\Robocopy.exe,"..\..\Shared Files" "..\Files"
'Ctrl + click to sync files: ide://run?file=%WINDIR%\System32\Robocopy.exe&args=..\..\Shared+Files&args=..\Files&FilesSync=True
#End Region

'Ctrl + click to export as zip: ide://run?File=%B4X%\Zipper.jar&Args=Project.zip

Sub Class_Globals
	Private Root As B4XView
	Private xui As XUI
	Public blanco = 0XFFFFFFFF As Int
	Public negro =  0XFF000000 As Int
	Private ean_13 As EAN13
	Dim CarpetaRaiz As String
	#if b4j
	Private Panel_EAN13 As Pane
	#else
	Private Panel_EAN13 As Panel
	Private rp As RuntimePermissions
	#end if
End Sub

Public Sub Initialize
'	B4XPages.GetManager.LogEvents = True
End Sub

'This event will be called once, before the page becomes visible.
Private Sub B4XPage_Created (Root1 As B4XView)
	Root = Root1
	Root.LoadLayout("MainPage")
	ean_13.Initialize
	#if b4a
	CarpetaRaiz = rp.GetSafeDirDefaultExternal("")
	#Else
	xui.SetDataFolder("CB")
	CarpetaRaiz = xui.DefaultFolder
	#End If
End Sub

Private Sub Button1_Click
	If CreaCodigoBarra("7453015138320") Then
		Log ("ok")
	End If
End Sub

Sub CreaCodigoBarra(codigo As String) As Boolean
	Private MyFont As B4XFont 'ignore
	Private MyFontBold As B4XFont

	#if b4j
	Private fx As JFX
	Private fntx As Font
	Private fntx2 As Font
	fntx = fx.LoadFont(File.DirAssets, "verdana.ttf", 10)
	MyFont = xui.CreateFont(fntx, 10)
	fntx2 = fx.LoadFont(File.DirAssets, "verdanab.ttf", 10)
	MyFontBold = xui.CreateFont(fntx2, 10)
	#else	
	Dim fntx As Typeface
	Dim fntx2 As Typeface
	fntx = Typeface.LoadFromAssets("verdana.ttf")
	MyFont = xui.CreateFont(fntx, 10)
	fntx2 = Typeface.LoadFromAssets("verdanab.ttf")
	MyFontBold = xui.CreateFont(fntx2, 10)
	#end if

	Dim primerdigito,izquierdo,derecho,docedigitos As String
	Dim NomArchivo_CB As String
	Dim cnvPanel As B4XCanvas

	docedigitos = codigo.SubString2(0,12)
	Dim cnvPnl As B4XCanvas
	cnvPnl.Initialize(Panel_EAN13)
	cnvPnl.DrawBitmap(ean_13.drawEAN13(docedigitos,blanco,negro),cnvPnl.TargetRect)
	primerdigito = ean_13.trece.SubString2(0,1)
	izquierdo = ean_13.trece.SubString2(1,7)
	derecho = ean_13.trece.SubString(7)
	Dim RectBlanco,Rect1,Rect2 As B4XRect
	Dim tope As Int = Panel_EAN13.Height-(Panel_EAN13.Height*20)/100
	RectBlanco.Initialize(0, Panel_EAN13.Height-(Panel_EAN13.Height*7)/100, Panel_EAN13.Width, Panel_EAN13.Height)
	Rect1.Initialize((Panel_EAN13.Width*11.5)/100, tope, (Panel_EAN13.Width*48.5)/100, Panel_EAN13.Height)
	Rect2.Initialize((Panel_EAN13.Width*51.5)/100, tope, (Panel_EAN13.Width*88.5)/100, Panel_EAN13.Height)
	cnvPnl.DrawRect(RectBlanco, blanco, True, 5dip)
	cnvPnl.DrawRect(Rect1, blanco, True, 5dip)
	cnvPnl.DrawRect(Rect2, blanco, True, 5dip)
	cnvPnl.DrawText(primerdigito,(Panel_EAN13.Width*5)/100,Panel_EAN13.Height-2dip,MyFontBold,negro,"CENTER")
	cnvPnl.DrawText(izquierdo,(Panel_EAN13.Width*29.8)/100,Panel_EAN13.Height-2dip,MyFontBold,negro,"CENTER")
	cnvPnl.DrawText(derecho,(Panel_EAN13.Width*70)/100,Panel_EAN13.Height-2dip,MyFontBold,negro,"CENTER")
	NomArchivo_CB = ean_13.trece & ".png"
	cnvPanel.Initialize(Panel_EAN13)

	Dim out2 As OutputStream
	out2 = File.OpenOutput(CarpetaRaiz, NomArchivo_CB, False)
	cnvPanel.CreateBitmap.WriteToStream(out2, 100, "PNG")
	out2.Close
	If File.Exists(CarpetaRaiz, NomArchivo_CB) Then
		Return True
	Else
		Return False
	End If
End Sub